// CdSの電圧変化をProcessingで視覚化（Processing側）
// 2017.12 nakayasu

import processing.serial.*; // シリアルライブラリの読み込み
Serial myPort; //シリアルポート
int[] cdsData; // グラフ用配列
int RxData; // 受信データ用変数

void setup()
{
  size(600, 255);
  cdsData = new int[width]; // ウィンドウ幅の配列初期化
  printArray(Serial.list()); // コンソールにシリアルデバイスの表示
  String portName = Serial.list()[3]; // シリアルデバイスナンバー
  myPort = new Serial(this, portName, 9600);
}

void draw()
{
  background(0); // 背景の更新
  stroke(60); // 中心線の色
  line(0, 127, width, 127); // 中心線の描画
  fill(255, 255, 0); //文字の色
  text("CdS Voltage(0-255): " + RxData, 10, 20); // 文字の描画

  stroke(255, 255, 0); // 点の色
  for(int i=1; i < width; i++) cdsData[i-1] = cdsData[i]; // 配列をずらしていく
  cdsData[width-1] = RxData; // 配列の最後に受信データを代入
  for(int i=1; i < width; i++) point(i, -1*cdsData[i]+255); // 配列（グラフ）の描画
}

void serialEvent(Serial myPort) {
  RxData = myPort.read(); //シリアル通信受信
}